---
title: Symbol.matchAll
slug: Web/JavaScript/Reference/Global_Objects/Symbol/matchAll
tags:
  - JavaScript
  - Property
  - Reference
  - Symbol
---
<div>{{JSRef}}</div>

<p>The <code><strong>Symbol.matchAll</strong></code> well-known symbol returns an iterator, that yields matches of the regular expression against a string. This function is called by the {{jsxref("String.prototype.matchAll()")}} method.</p>

<div>{{EmbedInteractiveExample("pages/js/symbol-matchall.html","shorter")}}</div>

<h2 id="Description">Description</h2>

<div>
<p>This Symbol is used for {{jsxref("String.prototype.matchAll()")}} and specifically in {{jsxref("RegExp.@@matchAll", "RegExp.prototype[@@matchAll]()")}}. The following two examples return same result:</p>

<pre class="brush: js">'abc'.matchAll(/a/);

/a/[Symbol.matchAll]('abc');</pre>

<p>This method exists for customizing match behavior within {{jsxref("RegExp")}} subclasses.</p>

<p>{{js_property_attributes(0,0,0)}}</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Symbol.matchAll">Using Symbol.matchAll</h3>

<pre class="brush: js">let re = /[0-9]+/g;
let str = '2016-01-02|2019-03-07';

const numbers = {
  *[Symbol.matchAll] (str) {
    for (const n of str.matchAll(/[0-9]+/g))
      yield n[0];
  }
};

console.log(Array.from(str.matchAll(numbers)));
//  Array ["2016", "01", "02", "2019", "03", "07"]
</pre>

<p>See {{jsxref("String.prototype.matchAll()")}} and {{jsxref("RegExp.@@matchAll", "RegExp.prototype[@@matchAll]()")}} for more examples.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-symbol.matchall', 'Symbol.matchAll')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Symbol.matchAll")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("String.prototype.matchAll()")}}</li>
 <li>{{jsxref("RegExp.@@matchAll", "RegExp.prototype[@@matchAll]()")}}</li>
</ul>
